<?php

/* ----------------------------------------------------------------------------------
 * 
 * Xaseco plugin to display a ingame manialink with message text.
 * everything is configureable via the config file, all values in config are initial values.
 * Everything like text, interval, position, size and style can be changed onthefly 
 * via admin chat commands. the chatcommand is made of 3 parts.
 * 
 * /[initial] [param] [value]
 * 
 * Command list:
 * /msgmod... for the initial command, have to be in front.
 * ....text "text" for the static and initial text
 * ....text(1,2,3) "text" for the 3 different random texts
 * ....interval "seconds" for the random interval, 0 for random off.
 * ....mpos "x y" for the main position (n.nn, n = numbers)
 * ....msize "x y" for the window size of window (n.nn, n = numbers)
 * ....tsize "n" (1 - 10) 
 * ....style "Mania Style" for the window style
 * ....substyle "Mania substyle" for the substyle
 *
 * find styles at http://fish.stabb.de/styles/
 *
 * if no param given, a little help text will be displayed.
 *
 * all new values given by chat commands are saved in config. 
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			nouseforname @ http://www.tm-forum.com
 * Home: 			tmf.game-host.org
 * Date: 			31.10.2009
 * Version:			1.0
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */

Aseco::registerEvent('onSync', 'init_message_manialinks');
Aseco::registerEvent('onStartup', 'message_loadSettings');
Aseco::registerEvent('onNewChallenge', 'message_on');
Aseco::registerEvent('onPlayerConnect', 'message_deal_with_players');
Aseco::registerEvent('onEndRace', 'message_off');
Aseco::registerEvent('onPlayerManialinkPageAnswer', 'message_handle_buttonclick');
Aseco::registerEvent('onChat', 'message_toggle_command');
Aseco::registerEvent('onEverySecond', 'msg_random_message');
Aseco::registerEvent('onPlayerDisconnect', 'msg_remove_player');

Aseco::addChatCommand('msgmod', 'Change Message window apperance.');

global $msginfotext, $msginfotext1, $msginfotext2, $msginfotext3, $msgstyle, $msgsubstyle;
global $msgmainposition, $msgmsize, $msgtextsize, $msginterval;
global $msgactive_players;
global $xml_message_on, $xml_message_off;
$msgactive_players = array();

// load xml configs
function message_loadSettings(){
	global $msginfotext, $msginfotext1, $msginfotext2, $msginfotext3, $msgstyle, $msgsubstyle;
	global $msgmainposition, $msgmsize, $msgtextsize, $msginterval;

	$file = file_get_contents('nouse_message_config.xml');
	$xml = simplexml_load_string($file);
	$msginfotext = strval($xml->infotext);
	$msginfotext1 = strval($xml->infotext1);
	$msginfotext2 = strval($xml->infotext2);
	$msginfotext3 = strval($xml->infotext3);
	$msginterval = intval($xml->msginterval);
	$msgmainposition = strval($xml->mainposition);
	$msgmsize = strval($xml->size);
	$msgtextsize = strval($xml->textsize);
	$msgstyle = strval($xml->style);
	$msgsubstyle = strval($xml->substyle);
}

function message_savesettings($param, $value) {
	global $msginfotext, $msginfotext1, $msginfotext2, $msginfotext3, $msgstyle, $msgsubstyle;
	global $msgmainposition, $msgmsize, $msgtextsize, $msginterval;
	
	$file = 'nouse_message_config.xml';
	
	$config = '<?xml version="1.0" encoding="utf-8" ?>' . CRLF;
	$config .= '<settings>' . CRLF;
	$config .= CRLF;
	$config .= "\t<!-- config file for plugin.nouse.info.php -->" . CRLF;
	$config .= "\t<!-- all values here are initial values and can be changed via admin command -->" . CRLF;
	$config .= "\t<infotext>".$msginfotext."</infotext>" . CRLF;
	$config .= "\t<infotext1>".$msginfotext1."</infotext1>" . CRLF;
	$config .= "\t<infotext2>".$msginfotext2."</infotext2>" . CRLF;
	$config .= "\t<infotext3>".$msginfotext3."</infotext3>" . CRLF;
	$config .= CRLF;
	$config .= "\t<msginterval>".$msginterval."</msginterval> <!-- interval in seconds, set tto \"0\" for random off -->" . CRLF;
	$config .= CRLF;
	$config .= "\t<mainposition>".$msgmainposition."</mainposition>" . CRLF;
	$config .= "\t<size>".$msgmsize."</size>" . CRLF;
	$config .= "\t<textsize>".$msgtextsize."</textsize>" . CRLF;
	$config .= CRLF;
	$config .= "\t<style>".$msgstyle."</style>" . CRLF;
	$config .= "\t<substyle>".$msgsubstyle."</substyle>" . CRLF;
	$config .= CRLF;
	$config .= '</settings>';
	
	//** write out XML file **//
	if (!@file_put_contents($file, $config)) {
		trigger_error('Could not write info config file ' . $file . ' !', E_USER_WARNING);
	}
}

function msg_random_message($aseco) {
	global $msginfotext, $msginfotext1, $msginfotext2, $msginfotext3;
	global $msgreset, $msginterval;
	$msgreset++;
	if ($msginterval) {
		if ($msgreset == $msginterval && $msginfotext != $msginfotext2 && $msginfotext != $msginfotext3) {
			$msginfotext = $msginfotext2;
			init_message_manialinks($aseco, $msginfotext);
			message_on($aseco);
		} elseif ($msgreset == $msginterval && $msginfotext != $msginfotext1 && $msginfotext != $msginfotext3) {
			$msginfotext = $msginfotext3;
			init_message_manialinks($aseco, $msginfotext);
			message_on($aseco);
		} elseif ($msgreset == $msginterval && $msginfotext != $msginfotext1 && $msginfotext != $msginfotext2) {
			$msginfotext = $msginfotext1;
			init_message_manialinks($aseco, $msginfotext);
			message_on($aseco);
		}
	}
}

// admin chat commands to  mod message window
function chat_msgmod($aseco, $command) {
	global $msginfotext, $msgstyle, $msgsubstyle, $msginterval;
	global $msginfotext1, $msginfotext2, $msginfotext3;
	global $msgmainposition, $msgmsize, $msgtextsize;
	$admin = $command['author'];
	$login = $admin->login;
	$nick = $admin->nickname;
	//$command['params'] = strtolower($command['params']);
	$com = explode(' ', $command['params'], 2);
	
	// check if chat command was allowed for a masteradmin/admin/operator
	if ($aseco->isMasterAdmin($admin) || $aseco->isAdmin($admin)) {
		// check for unlocked password (or unlock command)
		if ($aseco->settings['lock_password'] == '' || $admin->unlocked) {
			if ($com[0]) {
				switch ($com[0]) {
					case 'text':
						$msginfotext = $com[1];
						init_message_manialinks($aseco, $msginfotext);
						message_savesettings('infotext', $msginfotext);
					break;
					case 'text1':
						$msginfotext1 = $com[1];
						init_message_manialinks($aseco, $msginfotext1);
						message_savesettings('infotext1', $msginfotext1);
					break;
					case 'text2':
						$msginfotext2 = $com[1];
						init_message_manialinks($aseco, $msginfotext2);
						message_savesettings('infotext2', $msginfotext2);
					break;
					case 'text3':
						$msginfotext3 = $com[1];
						init_message_manialinks($aseco, $msginfotext3);
						message_savesettings('infotext3', $msginfotext3);
					break;
					case 'interval':
						$msginterval = $com[1];
						init_message_manialinks($aseco, $msginterval);
						message_savesettings('msginterval', $msginterval);
					break;
					case 'mpos':
						$msgmainposition = $com[1];
						init_message_manialinks($aseco, $msgmainposition);
						message_savesettings('mainposition', $msgmainposition);
					break;
					case 'msize':
						$msgmsize = $com[1];
						init_message_manialinks($aseco, $msgmsize);
						message_savesettings('size', $msgmsize);
					break;
					case 'tsize':
						$msgtextsize = $com[1];
						init_message_manialinks($aseco, $msgtextsize);
						message_savesettings('textsize', $msgtextsize);
					break;
					case 'style':
						$msgstyle = $com[1];
						init_message_manialinks($aseco, $msgstyle);
						message_savesettings('msgstyle', $msgstyle);
					break;
					case 'substyle':
						$msgsubstyle = $com[1];
						init_message_manialinks($aseco, $msgsubstyle);
						message_savesettings('msgsubstyle', $msgsubstyle);
					break;
					default:
					break;	
				}
				message_on($aseco);
			} else {
				$message = '{#server}> {#error}Missing parameter. Usage like $fff"/msgmod param value" $f80param: $i$ff0"msgtext(n)=text - msginterval=sec - msgpos=x y - msgmsize=x y - msgtsize=x y - msgstyle=STYLE - msgsubstyle=SUBSTYLE {#error}!';
				$aseco->client->query('ChatSendToLogin', $aseco->formatColors($message), $login);
			}
		} else {
			// write warning in console
			$aseco->console($login . ' tried to use admin chat command (not unlocked!): "/msgmod"');
			// show chat message
			$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that, unlock first!'), $login);
		}
	} else {
		// write warning in console
		$aseco->console($login . ' tried to use admin chat command (no permission!): "/msgmod" ');
		// show chat message
		$aseco->client->query('ChatSendToLogin', $aseco->formatColors('{#error}You don\'t have the required admin rights to do that!'), $login);
	}
}

function init_message_manialinks($aseco, $value=0) {
	global $xml_message_on, $xml_message_off;
	global $msgactive_players;
	global $msginfotext, $msgstyle, $msgsubstyle;
	global $msgmainposition, $msgmsize, $msgtextsize;

	$xml_message_on = '<manialink id="0815471122122">
		<frame posn="'.$msgmainposition.'">
			<quad posn="0 0 0" sizen="'.$msgmsize.'"  halign="center" valign="center" style="'.$msgstyle.'" substyle="'.$msgsubstyle.'" action="382009003" actionkey="3"   />
			<label posn="0 0.2 1" sizen="'.$msgmsize.'" halign="center" valign="center" textsize="'.$msgtextsize.'" text="'.$msginfotext.'" />
		</frame>
	</manialink>';

	$xml_message_off = '<manialink id="0815471122122">
	<frame posn="0 0 0">
	<quad posn="0 0 0" sizen="0 0" halign="center" valign="center" action="382009003" actionkey="3" /> 
	</frame>
	</manialink>';
}

// display manialink
function message_on($aseco) {
	global $msgactive_players;
	global $xml_message_on;
	global $msgreset;
	$msgreset = 0;
	$aseco->client->addCall('SendDisplayManialinkPageToLogin', array(implode(',', $msgactive_players), $xml_message_on, 0, false));
}  

// switch off manialink at roundsend
function message_off($aseco) {
	global $xml_message_off;
	global $msgreset;
	$msgreset = -900;
	$aseco->client->addCall('SendDisplayManialinkPage', array($xml_message_off, 0, false));
} 

// put playerlogins into array at player connect, and display manialink
function message_deal_with_players($aseco, $player) {
	global $msgactive_players, $xml_message_on;
	$msgactive_players[] = $player->login;
	$aseco->client->addCall('SendDisplayManialinkPageToLogin', array($player->login, $xml_message_on, 0, false));
}
 
// remove leaving players from array
function msg_remove_player($aseco, $player) {
	global $msgactive_players;
	$login = $player->login;
	
	if (in_array($login, $msgactive_players)) {
			$key = array_search($login, $msgactive_players);
			unset($msgactive_players[$key]);
			sort($msgactive_players);
	}
}
 
// F7 key press action id for widgets 382009003
// button click from menu "toggle widgets" 3831330
function message_handle_buttonclick($aseco, $command) {
	$login = $command[1];
	$action = $command[2];
	if ( $action == 382009003 || $action == 3831330 ) {
		message_change_player_status($aseco, $login);
	}
}

// change display status to specifig login
function message_change_player_status($aseco, $login) {
	global $msgactive_players;
	global $xml_message_on, $xml_message_off;
	if (in_array($login, $msgactive_players)) {
			$key = array_search($login, $msgactive_players);
			unset($msgactive_players[$key]);
			sort($msgactive_players);
			$aseco->client->addCall('SendDisplayManialinkPageToLogin', array( $login, $xml_message_off, 0, false));
		}
		else {
			$msgactive_players[] = $login;
			$aseco->client->addCall('SendDisplayManialinkPageToLogin', array($login, $xml_message_on, 0, false));
		}
}

// get chat command /togglewidgets from any player
function message_toggle_command($aseco, $command) {
	$playerid = $command[0];
	$login = $command[1];
	$action = $command[2];
	$state = $command[3];
	if ($playerid != 0 && $action == '/togglewidgets' && $state == 1) {
		message_change_player_status($aseco, $login);
	}
}
?>